//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
#property indicator_width1 2

//
//
//
//
//

extern int MinPeriod           = 10;
extern int MaxPeriod           = 20;
extern int Price               = PRICE_CLOSE;
extern int StdPeriod           = 14;
extern int NormalizationPeriod = 14;

double ema[];
double std[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(2);
      SetIndexBuffer(0,ema);
      SetIndexBuffer(1,std);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i=limit; i>=0; i--)
      {
         std[i] = iStdDev(NULL,0,StdPeriod,0,MODE_SMA,Price,i);
            double min = std[ArrayMinimum(std,NormalizationPeriod,i)];
            double max = std[ArrayMaximum(std,NormalizationPeriod,i)];
            if (min!=max)
                  double sto = (std[i]-min)/(max-min);
            else         sto = 0.5;
            double emaPeriod = MinPeriod+(1.0-sto)*(MaxPeriod-MinPeriod);
            double alpha     = 2.0 / (1.0 +emaPeriod);
            double price     = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         ema[i] = ema[i+1] +alpha*(price-ema[i+1]);
      }               
      return(0);
}